#!/usr/bin/env python
#
#\file AddEntry.py
#\brief Add new entried to DB
#\author Hideki Fujioka
#\date 01/09/2012
##
"""
\page Add New Entries
Usage:  AddEntry.py [DB] [NEW ENTRIES]
"""
import sys
import string
import os
import shutil
#
if (len(sys.argv) < 3):
    print "%s [ManyJOBS Data Base File] [New Entries File]\n" % (sys.argv[0])
    sys.exit()
#
if (False == os.path.isfile(sys.argv[1])):
    sys.exit("DB not exist")
if (False == os.path.isfile(sys.argv[2])):
    sys.exit("File not exist")
#
# get ManyJOBS dir
ManyJobsDir = os.path.dirname(os.path.abspath(sys.argv[0])) + "/localbin"
#
# Set Path and Import Modules
sys.path.append(ManyJobsDir)
import ManyJobsManager
#
# Read New Entries
inp = open(sys.argv[2],'r')
lines = inp.readlines()
inp.close()
#
# get Hosts & Jobs Data Base File name
manyJobsDB = os.path.abspath(sys.argv[1])
# init ManyJOBS manager
mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
#
for line in lines:
    if (line[0] == '#'):
        continue
    #print line
    mjm.addEntry(line)
#
# finalize ManyJOBS manager
mjm.finalize()
#
