#!/usr/bin/env python
#
#\file CopyScripts.py
#
#\brief Copy Scripts to Supercomputers
#\author Hideki Fujioka
#\date 05/03/2011
#
#08/09/2011 HF Modified
#
#Usage: CopyScripts.py [DB file] 
#
#
"""
\page  CopyScripts Copy Scripts to Clusters
Usage: CopyScripts.py [DB file] 
"""
import os
import sys
import string
#
#
if (len(sys.argv) < 2):
    print "%s [ManyJOBS Data Base File]\n" % (sys.argv[0])
    sys.exit()
if (False == os.path.isfile(sys.argv[1])):
    sys.exit("DB not exist")
#
# get ManyJOBS dir
MJDir = os.path.dirname(os.path.abspath(sys.argv[0]))
# Set Path and Import Modules
sys.path.append(MJDir+"/localbin")
import ManyJobsManager
import PauseList
from submit_job import *
#
# get Hosts & Jobs Data Base File name
manyJobsDB = os.path.abspath(sys.argv[1])
#
# init ManyJOBS manager
mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
#
# get host information
name = []
rhost = []
maxJobNum = []
jobLanch = []
[name,rhost,jobLanch,maxJobNum] = mjm.getClusterList()
#
# get secure copy
userscp = mjm.getSecureCopy()
#
# get secure shell
userssh = mjm.getSecureShell()
#
# finalize ManyJOBS manager
mjm.finalize()
#
# Copy Scripts
for i in range(len(name)):
    remoteUsrPath = os.path.dirname(jobLanch[i])
    remoteMJPath = os.path.dirname(remoteUsrPath)
    remoteBinPath = remoteMJPath + "/remotebin"
    command = "%s %s mkdir -p %s" % (userssh,rhost[i],remoteUsrPath)
    print command
    ans = commands.getoutput(command)
    print ans
    #
    command = "%s %s mkdir -p %s" % (userssh,rhost[i],remoteBinPath)
    print command
    ans = commands.getoutput(command)
    print ans
    #
    #
    command = "%s -r %s/* %s:%s" % (userscp,MJDir + "/remotebin",rhost[i],remoteMJPath + "/remotebin")
    print command
    ans = commands.getoutput(command)
    print ans
    #
    command = "%s -r %s/* %s:%s" % (userscp,MJDir + "/remoteusrbin",rhost[i],remoteMJPath + "/remoteusrbin")
    print command
    ans = commands.getoutput(command)
    print ans
    #
#
#
#
