#!/usr/bin/env python
#
#\file Flush.py
#\brief Flush Pause List.
#\author Hideki Fujioka
#\date 08/02/2011
##
"""
\page Flush Flush Pause List
Usage:  Flush.py [DB]
"""
import sys
import string
import os
import shutil
#
if (len(sys.argv) < 2):
    print "%s [ManyJOBS Data Base File\n" % (sys.argv[0])
    sys.exit()
if (False == os.path.isfile(sys.argv[1])):
    sys.exit("DB not exist")
#
# get ManyJOBS dir
ManyJobsDir = os.path.dirname(os.path.abspath(sys.argv[0])) + "/localbin"
#
# Set Path and Import Modules
sys.path.append(ManyJobsDir)
import ManyJobsManager
import PauseList
import StatusDatabase
from submit_job import *
from checkGhostJobs import *
#
# get Hosts & Jobs Data Base File name
manyJobsDB = os.path.abspath(sys.argv[1])
# 
# Check Ghost Tasks
checkGhostJobs(manyJobsDB)
#
# Resubmit to paused hosts
pausedClusterNames = []
pList = PauseList.PauseList(manyJobsDB)
while True:
    pcn = pList.getPausedHost()
    if (pcn == None):
        break
    pausedClusterNames.append(pcn)
#
pList.finalize() 
#
# Submit Jobs
for pausedClusterName in pausedClusterNames:
    # init ManyJOBS manager
    mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
    # get information for the cluster
    localhostName = mjm.getLocalHost()
    rhost = mjm.getClusterAddressByName(pausedClusterName)
    jabLaunch = mjm.getJobSubmitLauncherByName(pausedClusterName)
    msg = "Get %s from the paused host list." % (pausedClusterName)
    log_file(os.path.dirname(manyJobsDB),msg)
    #
    optionSt = mjm.getOptionStringByName(pausedClusterName)
    # finalize ManyJOBS manager
    mjm.finalize()
    #
    if (rhost == "None"):
        continue
    #
    #  submit a new job
    submitJob(pausedClusterName,rhost,jabLaunch,localhostName,ManyJobsDir,manyJobsDB,optionSt)
    #
#
#
#
