#!/usr/bin/env python
##\file SubmitNewJob.py
##\brief Submit a new job
##\author Hideki Fujioka
##\date 01/09/2012
#
# 01/09/2012 Last Modified by Hideki Fujioka 
#
import os
import sys
import string
import shutil
#
#
if (len(sys.argv) < 3):
    print "%s [ManyJOBS Data Base File] [Cluster name]\n" % (sys.argv[0])
    sys.exit()
if (False == os.path.isfile(sys.argv[1])):
    sys.exit("DB not exist")
#
# get ManyJOBS dir
ManyJobsDir = os.path.dirname(os.path.abspath(sys.argv[0])) + "/localbin"
#
# Set Path and Import Modules
sys.path.append(ManyJobsDir)
import ManyJobsManager
import PauseList
import StatusDatabase
from submit_job import *
#
#
# get Hosts & Jobs Data Base File name
manyJobsDB = os.path.abspath(sys.argv[1])
#
# init ManyJOBS manager
mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
#
#
# Get Local Host
UserHostName = mjm.getLocalHost()
#
# get host information
name = []
rhost = []
maxJobNum = []
jobLanch = []
[name,rhost,jobLanch,maxJobNum] = mjm.getClusterList()
#
# get secure copy
userscp = mjm.getSecureCopy()
#
# get secure shell
userssh = mjm.getSecureShell()
#
# get option string
optionString = []
for na in name:
    optionString.append(mjm.getOptionStringByName(na))    
#
# finalize ManyJOBS manager
mjm.finalize()
#
#
# Submit a JOB
for i in range(len(name)):
    if (name[i] == sys.argv[2]):
        # Create LOG dirctory on Remote Host
        remoteUsrPath = os.path.dirname(jobLanch[i])
        remoteLogPath = os.path.dirname(remoteUsrPath)+"/log"
        command = "%s %s mkdir -p %s" % (userssh,rhost[i],remoteLogPath)
        commands.getoutput(command)
        #
        ## Submit Job
        submitJob(name[i],rhost[i],jobLanch[i],UserHostName,ManyJobsDir,manyJobsDB,optionString[i])
        break
#

