#
## Check Ghost Jobs
#
#
# 01/05/2012 Created by Hideki Fujioka
#
#
import os
import sys
import commands
import string
import time
import datetime
#
import ManyJobsManager
import StatusDatabase
from log_file import *
#
def checkGhostJobs(manyJobsDB):
    """ Check Active Jobs Running for longer than WALLTIME """
    # get a list of active jobs
    log_file(os.path.dirname(manyJobsDB),"get active job list")
    statusDB = StatusDatabase.StatusDatabase(manyJobsDB)
    [host,jobID,startTime,tasks] = statusDB.getActiveJobList()
    log_file(os.path.dirname(manyJobsDB),"sucess")
    statusDB.finalize()

    for i in range(len(jobID)):
        # init ManyJOBS manager
        mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
        wt = mjm.getWallTimeByName(host[i])
        mjm.finalize()
        if (wt == 'None'):
            continue
        log_file(os.path.dirname(manyJobsDB),wt)
        et = wt.split(':')
        dt = datetime.timedelta(0,int(et[2]),0,0,int(et[1]),int(et[0]),0)
        td = datetime.datetime.today()
        if (td > startTime[i] + dt):
            # job may be crushed
            # Report tasks Jobs crushed
            numOfTasks = len(tasks[i])
            tStatus = []
            for i in range(numOfTasks):
                tStatus.append('CRUSHED')
            #
            statusDB = StatusDatabase.StatusDatabase(manyJobsDB)            
            statusDB.reportTasksToFinished(numOfTasks,tasks[i],tStatus,jobID[i])
            statusDB.reportJobToFinished(host[i],jobID[i])
            statusDB.finalize()
            #
            # Switch Tasks back to 'Queued'
            mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
            for task in tasks[i]:
                mjm.reportFinishedTask(task,'CRUSHED')
            mjm.finalize()
            #msg = "JOB " + jobID[i]
            #msg = msg + " started on " + startTime[i].isoformat()
            #msg = msg + " passed walltime " + dt.isoformat()
            #log_file(os.path.dirname(manyJobsDB),msg)
        #
    #
#
