#
# Flush Pause List
#
# 08/08/2011 HF Created
# 03/21/2012 Last Modified by Hideki Fujioka
#
import sys
import string
import os
import shutil
#
import ManyJobsManager
import PauseList
import StatusDatabase
from submit_job import *
#
def flushPausedHost(manyJobsDB,suspendedClusterName):
    #
    # ManyJobs Master Dir
    ManyJobsDir = os.path.dirname(os.path.abspath(sys.argv[0]))
    #
    # Get Cluster Info
    mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
    [name,rhost,jobLanch,maxJobNum] = mjm.getClusterList()
    localhostName = mjm.getLocalHost()
    optionString = []
    for na in name:
        optionString.append(mjm.getOptionStringByName(na))
    # Check Avaiable Tasks
    numberOfAvailableTasks = mjm.numberOfTasksToRun()
    mjm.finalize()

    # Resubmit to paused hosts
    pausedClusterNames = []
    pList = PauseList.PauseList(manyJobsDB)
    while True:
        pcn = pList.getPausedHost()
        # Skip error cluster
        if (pcn == suspendedClusterName):
            continue        
        if (pcn == None):
            break
        pausedClusterNames.append(pcn)
    #
    pList.finalize() 
    #
    # Submit Jobs
    for i in range(len(name)):
        count = pausedClusterNames.count(name[i])
        if (count >= numberOfAvailableTasks):
            count = numberOfAvailableTasks
        if (count >= int(maxJobNum[i])):
            count = int(maxJobNum[i])
        #
        #  submit a new job
        if (count <= 0):
            continue
        for j in range(count):
            pausedClusterNames.remove(name[i])        
            submitJob(name[i],rhost[i],jobLanch[i],localhostName,ManyJobsDir,manyJobsDB,optionString[i])
        msg = "%d jobs sumitted to %s from the paused host list." % (count,name[i])
        log_file(os.path.dirname(manyJobsDB),msg)
    #
    # set back to Pause List
    if (len(pausedClusterNames) > 0):
        pList = PauseList.PauseList(manyJobsDB)
        for pcn in pausedClusterNames:
            pList.addPausedHost(pcn)
        #
        pList.finalize()
    #
