#
## Submit a Job 
#
#
# 11/09/2009 Created by Hideki Fujioka
# 12/14/2011 Last Modified by Hideki Fujioka.
#
#
import os
import sys
import commands
import string
import time
#
import ManyJobsManager
import StatusDatabase
from log_file import *
#
## \fn submitJob(name,rhost,jabLauch,localhostName,ManyJobsDir,manyJobsDB,optionString)
def submitJob(name,rhost,jabLauch,localhostName,ManyJobsDir,manyJobsDB,optionString):   
    """ submit a job
    \param name Cluster Nick-Name
    \param rhost Cluster Address
    \param jabLauch Job Submission Launcher
    \param localhostName Localhost userID\@address
    \param ManyJobsDir ManyJobs main Dir on Localhost
    \param manyJobsDB  Database File Name
    \param optionString  options for job-submission command (qsub)
    """
    # init ManyJOBS manager
    mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
    userssh = mjm.getSecureShell()
    #
    # Check if there are things to do..
    if (False == mjm.ifThingsToDo()):
        mjm.finalize()
        msg = "No more things to do on " + name
        log_file(os.path.dirname(manyJobsDB),msg)
        return
    #
    # submit job
    try:
        arguments = name + " " + localhostName + " " + ManyJobsDir + " " + manyJobsDB
        executable = jabLauch
        #
        command = '%s %s %s %s %s' % (userssh, rhost, executable, arguments, optionString)
        ans = commands.getoutput(command)
        #
        #print ans
        #print command
    except:
        print rhost,"is invalid HOST"
        # Delete lock file
        mjm.finalize()
        return
    #
    # Append jobs.log file
    # LOOK FOR "MANYJOBID"
    #print ans
    ent1 = ans.split('\n')
    jobID = ""
    for i in range(len(ent1)):
        ent2 = ent1[i].split('=')
        if (ent2[0] == 'MANYJOBID'):
            jobID = ent2[1]
    #
    if (jobID == ""):
        print "no JOBID returned\n"
        jobID = "NO-ID"
    #
    msg = "Submitted " + name + " ID=" + jobID
    log_file(os.path.dirname(manyJobsDB),msg)
    print msg
    #
    # finalize ManyJOBS manager
    mjm.finalize()
    #
    # Add job to status database
    statusDB = StatusDatabase.StatusDatabase(manyJobsDB)
    statusDB.addJobSubmitted(name,jobID)
    statusDB.finalize()
#
#
