#!/usr/bin/env python
##\file job_loni_del.py
##\brief Delete a Job on LONI LINUX Cluster
##\author Hideki Fujioka
##\date 08/18/2010
##
## 05/09/2011 Last Madified by Hidek Fujioka
##
"""
\page JobKillingScripts Job Killing Script

\section intro_JobKillingScripts Introduction

This script is to kill a job, which you have to prepare
one for one \ref JobSubmisionScripts.
The name of this file must be [job-submission script base name]_del.py,
for example, if the job-submission script name is 'job_loni.py', 
this file must be 'job_loni_del.py'.

\section inputs_reture_JS_script Input and Return Values
\ref MANYJOBS_JOBID is required for a input.
This script kill the job of the \ref MANYJOBS_JOBID on the cluster.
No retuen values.


"""
import sys
import string
import os
import commands
import time
#
# batch job information
#
dirname = os.path.dirname(sys.argv[0])
remoteBinDir = os.path.dirname(dirname) + "/remotebin"
sys.path.append(remoteBinDir)
from log_file import *
#
logDir =  os.path.dirname(remoteBinDir) + "/log"
os.chdir(dirname)
#
#
jobID = sys.argv[1]
#
# This is the command to kill a job.
command = "qdel %s " % (jobID) 
#
# KILL A JOB ON PBS
ans = commands.getoutput(command)
log_file(logDir,ans)
#
#

